/****************************************************************************
 ** ScStw Styling
 ** Copyright (C) 2020  Itsblue development
 **
 ** This program is free software: you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation, either version 3 of the License, or
 ** (at your option) any later version.
 **
 ** This program is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 **
 ** You should have received a copy of the GNU General Public License
 ** along with this program.  If not, see <http://www.gnu.org/licenses/>.
 ****************************************************************************/

#ifndef SCSTWAPPTHEMEMANAGER_H
#define SCSTWAPPTHEMEMANAGER_H

#include <QObject>
#include <QColor>
#include "scstwapptheme.h"

class ScStwAppThemeManager : public QObject
{
    Q_OBJECT
    Q_PROPERTY(ScStwAppTheme* theme READ getTheme NOTIFY themeChanged)
    Q_PROPERTY(QString themeName READ getThemeName WRITE setTheme NOTIFY themeChanged)

public:
    explicit ScStwAppThemeManager(QObject *parent = nullptr);

private:
    QList<ScStwAppTheme*> themes;
    ScStwAppTheme* currentTheme;

    ScStwAppTheme* findThemeByName(QString themeName);

    QString lighter(QString color, double factor);

signals:
    void themeChanged();

public slots:
    ScStwAppTheme* getTheme();
    Q_INVOKABLE bool setTheme(QString themeName);
    Q_INVOKABLE QString getThemeName();

};

#endif // SCSTWAPPTHEMEMANAGER_H
